#include <iostream>
using std::cout;
using std::endl;

#include <vector>
using std::vector;

#include <limits>
using std::numeric_limits;

#include "bitconvert.h"

#include "rand.hpp"

rnd<linear_congruential<1664525,1013904223> > R(25);
//rnd<lagged_fibonacci<25,56, linear_congruential<1664525,1013904223> > > L(99);
//rnd<quadratic_congruential<1,1,1> > Q(10294382);
//rnd<middle16_bits> M(293823);
//rnd<middle32_bits> MM(293823);

template <typename RandNumGen>
void random_walk(RandNumGen &RNG)
{
	const size_t steps = 15000;
	
	vector<double> ave(steps);
	vector<double> var(steps);

	for (size_t i = 0; i < steps; ++i)
		ave[i] = var[i] = 0.;

	const unsigned int N = 100;
	for (unsigned int n = 0; n < N; ++n)
	{
		int pos = 0;
		for (size_t i = 1; i < steps; ++i)
		{
			if (RNG() < RNG())
				++pos;
			else
				--pos;
			ave[i] += pos;
			var[i] += pos*pos;
		}
	}
	
	for (size_t i = 0; i < steps; ++i)
		ave[i] /= N;

	for (size_t i = 0; i < steps; ++i)
	{
		var[i] /= N;
		var[i] -= ave[i]*ave[i];
	}
	
	for (size_t i = 0; i < steps; ++i)
		if (i%100 == 0)
			cout << (i+1) << "\t" << ave[i] << "\t" << var[i] << endl;

	cout << endl << endl;
}

int main()
{	
	random_walk(R);
//	random_walk(L);
//	random_walk(Q);
//	random_walk(M);
//	random_walk(MM);
	
	return 0;
}